########### SETTINGS TO ADJUST ################################################
# 2024-04-19
# https://www.drassal.net/wp

# script to easily generate a CA to self sign SSL certificates

#parameters for CA root certificate
CA_COUNTRY="US"
CA_STATE="CA"
CA_LOCALITY="Los Angeles"
CA_ORGANIZATIONUNIT=""
CA_COMMONNAME=""
###############################################################################

CA_ORGANIZATION=$1
CA_VALID_DAYS=$2

FILEPATH_ROOT=${PWD}
FILEPATH_CA="${FILEPATH_ROOT}/ca"

FILEPATH_CERT_OPENSSL_CONF=${FILEPATH_CA}/openssl.cnf

FILEPATH_CERT_CA_KEY="${FILEPATH_CA}/ca.key"
FILEPATH_CERT_CA_CRT="${FILEPATH_CA}/ca.crt"

#generate CA key and certificate
if ! [ -n "$CA_ORGANIZATION" ]
then
  echo "CA_ORGANIZATION (first command line parameter) is empty"
  echo "example"
  echo "./create_ca.sh \"mydomain.net Root CA\""
  exit
fi

CA_SUBJECT="/C=${CA_COUNTRY}/ST=${CA_STATE}/L=${CA_LOCALITY}/O=${CA_ORGANIZATION}/OU=${CA_ORGANIZATIONUNIT}/CN=${CA_COMMONNAME}/"

if ! [ -n "$CA_VALID_DAYS" ]
then
  CA_VALID_DAYS=3650
fi

#private key password can be set by removing the "-nodes" line below
openssl req \
        -x509 \
        -newkey rsa:2048 \
        -nodes \
        -sha256 \
        -days ${CA_VALID_DAYS} \
        -subj "${CA_SUBJECT}" \
        -keyout ${FILEPATH_CERT_CA_KEY} \
        -out    ${FILEPATH_CERT_CA_CRT} \
        -config ${FILEPATH_CERT_OPENSSL_CONF}
openssl x509 -in ${FILEPATH_CERT_CA_CRT} -text -noout
